/*
 * Part of winebottle 0.1.  See file COPYING for notices and license.
 *
 * Authors : Johan Ceuppens
 */

#include "class.h"
#include "types.h"
#include <map>
#include <functional>
#include "classinstance.h"
#include "mapiterator.h"

template <class Map>
Class<Map>::Class()
{}

template<class Map>
Class<Map>::~Class()
{}

template<class Map>
Class<Map> *Class<Map>::dispatch()
{
	return this;
}

template<class Map>
Class<Map> *Class<Map>::dipatch_class_method(std::string methodname)
{
	for (MapIterator iterator = _methods.begin(); iterator != _methods.end(); iterator++)
		if ((*iterator)/**.first**/ == methodname) {
			iterator.dispatch();
			return this;
		}
	return NULL;
}

template class Class<std::map<la::ID, std::mem_fun_ref_t<ClassInstance, ClassInstance> > >;
